package nc.impl.sscivm.invoiceledger.workplugin;

package ..deTemp.1729433767451;

import com.google.common.collect.Maps;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.UUID;
import java.util.stream.Collectors;
import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.pa.PreAlertReturnType;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.bs.trade.business.HYPubBO;
import nc.cmp.utils.Lists;
import nc.itf.arap.pay.IArapPayBillQueryService;
import nc.itf.arap.payable.IArapPayableBillQueryService;
import nc.itf.arap.prv.IBXBillPrivate;
import nc.itf.arap.receivable.IArapReceivableBillQueryService;
import nc.itf.sscivm.invoiceledger.invoiceledgerinfo.IInvoiceLedgerInfoVOService;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.tools.LoggerTools;
import nc.ui.dbcache.DBCacheQueryFacade;
import nc.vo.arap.arap_bill_invoice.ArapBillInvoiceVO;
import nc.vo.arap.pay.AggPayBillVO;
import nc.vo.arap.pay.PayBillItemVO;
import nc.vo.arap.pay.PayBillVO;
import nc.vo.arap.payable.AggPayableBillVO;
import nc.vo.arap.payable.PayableBillItemVO;
import nc.vo.arap.payable.PayableBillVO;
import nc.vo.arap.receivable.AggReceivableBillVO;
import nc.vo.arap.receivable.ReceivableBillItemVO;
import nc.vo.arap.receivable.ReceivableBillVO;
import nc.vo.ep.bx.BXBusItemVO;
import nc.vo.ep.bx.JKBXHeaderVO;
import nc.vo.ep.bx.JKBXVO;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.ISuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.BillStatusEnum;
import nc.vo.sscivm.invoice.AggInvoiceLedgerInfoVO;
import nc.vo.sscivm.invoice.ArrivalTicketState;
import nc.vo.sscivm.invoice.InvoiceAuthType;
import nc.vo.sscivm.invoice.InvoiceLedgerInfoVO;
import nc.vo.sscivm.invoice.NcSourceType;
import nc.vo.sscivm.invoice.SourceType;
import nccloud.commons.collections.CollectionUtils;
import nccloud.commons.lang.StringUtils;

public class InvoiceLedgerInfoInterface implements IBackgroundWorkPlugin {
  BaseDAO baseDAO = new BaseDAO();
  
  HYPubBO hyPubBO = new HYPubBO();
  
  private final String F1_CXX_YFGZ = "F1-Cxx-YFGZ";
  
  private final String F1_CXX_YFJS = "F1-Cxx-YFJS";
  
  private final String F1_CXX_YFMD = "F1-Cxx-YFMD";
  
  private final String F1_CXX_01 = "F1-Cxx-01";
  
  private final String F1_CXX_02 = "F1-Cxx-02";
  
  private final String F1_CXX_03 = "F1-Cxx-03";
  
  private final String F1_CXX_04 = "F1-Cxx-04";
  
  private final String F1_CXX_05 = "F1-Cxx-05";
  
  private final String F1_CXX_06 = "F1-Cxx-06";
  
  private final String F1_CXX_07 = "F1-Cxx-07";
  
  private final String F1_CXX_08 = "F1-Cxx-08";
  
  private final String F1_CXX_09 = "F1-Cxx-09";
  
  private final String F1_CXX_10 = "F1-Cxx-10";
  
  public PreAlertObject executeTask(BgWorkingContext bgwc) throws BusinessException {
    LoggerTools.error("单据发票同步发票台账开始！");
    PreAlertObject alert = new PreAlertObject();
    alert.setReturnType(PreAlertReturnType.RETURNNOTHING);
    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
    String format = formatter.format(new Date());
    Map<String, Object> map = bgwc.getKeyMap();
    String begintime = Objects.isNull(map.get("begintime")) ? "" : map.get("begintime").toString();
    if (StringUtils.isBlank(begintime)) {
      begintime = String.valueOf(format) + " 00:00:00";
    } else {
      begintime = String.valueOf(begintime) + " 00:00:00";
    } 
    String endtime = Objects.isNull(map.get("endtime")) ? "" : map.get("endtime").toString();
    if (StringUtils.isBlank(endtime)) {
      endtime = String.valueOf(format) + " 23:59:59";
    } else {
      endtime = String.valueOf(endtime) + " 23:59:59";
    } 
    String userCode = Objects.isNull(map.get("userCode")) ? "" : map.get("userCode").toString();
    if (StringUtil.isEmpty(userCode)) {
      bgwc.setLogStr("默认操作员不能为空");
      return alert;
    } 
    String s1 = "select cuserid from sm_user where user_code='" + userCode + "' and isnull(dr,0)=0";
    String pk_user = (String)DBCacheQueryFacade.runQuery(s1, (ResultSetProcessor)new ColumnProcessor());
    if (StringUtil.isEmpty(pk_user)) {
      bgwc.setLogStr("默认操作员" + userCode + "非法");
      return alert;
    } 
    InvocationInfoProxy.getInstance().setUserId(pk_user);
    List<AggInvoiceLedgerInfoVO> saveVOList = Lists.newArrayList();
    StringBuilder error = new StringBuilder();
    try {
      List<AggInvoiceLedgerInfoVO> bxSaveVOList = bxd(begintime, endtime);
      saveVOList.addAll(bxSaveVOList);
    } catch (Exception e) {
      LoggerTools.error("报销单发票信息同步失败，错误信息：" + e);
      String logString = Objects.isNull(bgwc.getLogString()) ? "" : bgwc.getLogString();
      bgwc.setLogStr(String.valueOf(logString) + "报销单发票信息同步失败，错误信息：" + e + "\n");
    } 
    try {
      List<AggInvoiceLedgerInfoVO> yfdOaSaveVOList = yfdOa(begintime, endtime);
      saveVOList.addAll(yfdOaSaveVOList);
    } catch (Exception e) {
      LoggerTools.error("应付单-已到票发票信息同步失败，错误信息：" + e);
      String logString = Objects.isNull(bgwc.getLogString()) ? "" : bgwc.getLogString();
      bgwc.setLogStr(String.valueOf(logString) + "应付单-已到票发票信息同步失败，错误信息：" + e + "\n");
    } 
    Map<String, AggInvoiceLedgerInfoVO> target = Maps.newHashMap();
    for (AggInvoiceLedgerInfoVO vo : saveVOList) {
      List<String> nc_source_billnoList = Lists.newArrayList();
      InvoiceLedgerInfoVO parentVO = vo.getParentVO();
      String key = UUID.randomUUID().toString();
      if (StringUtils.isNotBlank(parentVO.getInvoice_number()) && StringUtils.isNotBlank(parentVO.getInvoice_code()) && 
        StringUtils.isNotBlank(parentVO.getCost_center()) && StringUtils.isNotBlank(parentVO.getVoucher_no()))
        key = String.valueOf(parentVO.getInvoice_number()) + parentVO.getInvoice_code() + parentVO.getCost_center() + parentVO.getVoucher_no(); 
      if (target.containsKey(key)) {
        AggInvoiceLedgerInfoVO valueAggVO = target.get(key);
        InvoiceLedgerInfoVO valueVO = valueAggVO.getParentVO();
        UFDouble tax = valueVO.getTax();
        UFDouble tax_exclusive = valueVO.getTax_exclusive();
        UFDouble total_price_with_tax = valueVO.getTotal_price_with_tax();
        String nc_source_billno = valueVO.getNc_source_billno();
        if (StringUtils.isNotBlank(nc_source_billno))
          nc_source_billnoList.addAll(Arrays.asList(nc_source_billno.split(","))); 
        parentVO.setTax(parentVO.getTax().add(tax));
        parentVO.setTax_exclusive(parentVO.getTax_exclusive().add(tax_exclusive));
        parentVO.setTotal_price_with_tax(parentVO.getTotal_price_with_tax().add(total_price_with_tax));
        if (StringUtils.isNotBlank(parentVO.getNc_source_billno()))
          nc_source_billnoList.add(parentVO.getNc_source_billno()); 
      } 
      if (CollectionUtils.isNotEmpty(nc_source_billnoList))
        parentVO.setNc_source_billno(nc_source_billnoList.stream().distinct().collect(Collectors.joining(","))); 
      target.put(key, vo);
    } 
    saveVOList = new ArrayList<>(target.values());
    try {
      List<AggInvoiceLedgerInfoVO> fkdSaveVOList = fkd(begintime, endtime);
      saveVOList.addAll(fkdSaveVOList);
    } catch (Exception e) {
      LoggerTools.error("付款单发票信息同步失败，错误信息：" + e);
      String logString = Objects.isNull(bgwc.getLogString()) ? "" : bgwc.getLogString();
      bgwc.setLogStr(String.valueOf(logString) + "付款单发票信息同步失败，错误信息：" + e + "\n");
    } 
    try {
      List<AggInvoiceLedgerInfoVO> yfdOaAndJmsSaveVOList = yfdOAAndJms(begintime, endtime);
      saveVOList.addAll(yfdOaAndJmsSaveVOList);
    } catch (Exception e) {
      LoggerTools.error("应付单-未到票发票信息同步失败，错误信息：" + e);
      String logString = Objects.isNull(bgwc.getLogString()) ? "" : bgwc.getLogString();
      bgwc.setLogStr(String.valueOf(logString) + "应付单-未到票发票信息同步失败，错误信息：" + e + "\n");
    } 
    try {
      List<AggInvoiceLedgerInfoVO> ysdJmsSaveVOList = ysdJms(begintime, endtime);
      saveVOList.addAll(ysdJmsSaveVOList);
    } catch (Exception e) {
      LoggerTools.error("应收单-发票信息同步失败，错误信息：" + e);
      String logString = Objects.isNull(bgwc.getLogString()) ? "" : bgwc.getLogString();
      bgwc.setLogStr(String.valueOf(logString) + "应收单-发票信息同步失败，错误信息：" + e + "\n");
    } 
    if (CollectionUtils.isEmpty(saveVOList))
      return null; 
    IInvoiceLedgerInfoVOService iInvoiceLedgerInfoVOService = (IInvoiceLedgerInfoVOService)NCLocator.getInstance().lookup(IInvoiceLedgerInfoVOService.class);
    AggInvoiceLedgerInfoVO[] result = iInvoiceLedgerInfoVOService.saveAggInvoiceLedgerInfoVO(saveVOList.<AggInvoiceLedgerInfoVO>toArray(new AggInvoiceLedgerInfoVO[0]));
    LoggerTools.error("单据发票同步发票台账结束！");
    return null;
  }
  
  private List<AggInvoiceLedgerInfoVO> ysdJms(String begintime, String endtime) throws BusinessException {
    List<AggInvoiceLedgerInfoVO> saveVOList = Lists.newArrayList();
    IArapReceivableBillQueryService iArapReceivableBillQueryService = getIArapReceivableBillQueryService();
    AggReceivableBillVO[] ysdArr = iArapReceivableBillQueryService.queryVOsByWhere(" DR = 0 and BILLDATE >= '" + begintime + "' and BILLDATE <= '" + endtime + "'");
    if (Objects.isNull(ysdArr) || ysdArr.length <= 0)
      return Lists.newArrayList(); 
    List<AggReceivableBillVO> ysdList = Arrays.asList(ysdArr);
    String ysdInvoiceSql = "select * from arap_bill_invoice where DR = 0 AND SOURCE_NO IN (SELECT pk_recbill FROM ar_recbill WHERE DR = 0 and BILLDATE >= '" + begintime + "' and BILLDATE <= '" + endtime + "')";
    List<ArapBillInvoiceVO> ysdInvoiceList = (List<ArapBillInvoiceVO>)this.baseDAO.executeQuery(ysdInvoiceSql, (ResultSetProcessor)new BeanListProcessor(ArapBillInvoiceVO.class));
    if (CollectionUtils.isEmpty(ysdInvoiceList))
      return Lists.newArrayList(); 
    Map<String, List<ArapBillInvoiceVO>> sourceNoListMap = (Map<String, List<ArapBillInvoiceVO>>)ysdInvoiceList.stream().collect(Collectors.groupingBy(ArapBillInvoiceVO::getSource_no));
    int count = 0;
    List<String> existInvoiceMap = Lists.newArrayList();
    StringBuilder distinctInvoiceSql = new StringBuilder();
    for (int i = 0; i < ysdInvoiceList.size(); i++) {
      ArapBillInvoiceVO billInvoiceVO = ysdInvoiceList.get(i);
      if (!Objects.isNull(billInvoiceVO)) {
        String invoiceNumber = StringUtils.isNotBlank(billInvoiceVO.getInvoice_number()) ? billInvoiceVO.getInvoice_number() : "";
        String invoiceCode = StringUtils.isNotBlank(billInvoiceVO.getInvoice_code()) ? billInvoiceVO.getInvoice_code() : "~";
        String costCenter = billInvoiceVO.getCost_center();
        if (StringUtils.isNotBlank(invoiceNumber) || StringUtils.isNotBlank(invoiceCode)) {
          distinctInvoiceSql.append(" ( ");
          distinctInvoiceSql.append(" invoice_number = '").append(invoiceNumber).append("' ");
          distinctInvoiceSql.append(" and NVL(invoice_code, '~') = '").append(invoiceCode).append("' ");
          distinctInvoiceSql.append(" and cost_center = '").append(costCenter).append("' ");
          distinctInvoiceSql.append(" ) ");
          if (i < ysdInvoiceList.size() - 1)
            distinctInvoiceSql.append(" or "); 
        } 
        count++;
        if (count == 1000 || i == ysdInvoiceList.size() - 1) {
          if (distinctInvoiceSql.toString().endsWith("or "))
            distinctInvoiceSql.delete(distinctInvoiceSql.length() - 4, distinctInvoiceSql.length()); 
          if (StringUtils.isBlank(distinctInvoiceSql))
            distinctInvoiceSql.append(" 1 != 1 "); 
          distinctInvoiceSql.append(" AND DR = 0 ");
          List<String> newExistInvoiceMap = getExistInvoice(distinctInvoiceSql.toString(), false);
          if (CollectionUtils.isNotEmpty(newExistInvoiceMap))
            existInvoiceMap.addAll(newExistInvoiceMap); 
          count = 0;
          distinctInvoiceSql = new StringBuilder();
        } 
      } 
    } 
    String ydpBillPk = (String)this.hyPubBO.findColValue("BD_BILLTYPE", "PK_BILLTYPEID", " PK_BILLTYPECODE = 'FPRZFPTZ-Cxx-005'");
    for (AggReceivableBillVO ysd : ysdList) {
      if (Objects.isNull(ysd))
        continue; 
      ReceivableBillVO receivableBillVO = (ReceivableBillVO)ysd.getParentVO();
      if (Objects.isNull(receivableBillVO))
        continue; 
      ReceivableBillItemVO[] receivableBillItemVOS = (ReceivableBillItemVO[])ysd.getChildrenVO();
      if (receivableBillItemVOS == null || receivableBillItemVOS.length <= 0)
        continue; 
      String supplier = receivableBillItemVOS[0].getSupplier();
      List<ArapBillInvoiceVO> sourceNoList = sourceNoListMap.get(receivableBillVO.getPk_recbill());
      if (CollectionUtils.isEmpty(sourceNoList))
        continue; 
      for (ArapBillInvoiceVO ysdInvoice : sourceNoList) {
        if (Objects.isNull(ysdInvoice))
          continue; 
        String invoice_number = StringUtils.isNotBlank(ysdInvoice.getInvoice_number()) ? ysdInvoice.getInvoice_number() : "";
        String invoice_code = StringUtils.isNotBlank(ysdInvoice.getInvoice_code()) ? ysdInvoice.getInvoice_code() : "";
        String cost_center = StringUtils.isNotBlank(ysdInvoice.getCost_center()) ? ysdInvoice.getCost_center() : "";
        if (CollectionUtils.isNotEmpty(existInvoiceMap) && existInvoiceMap.contains(String.valueOf(invoice_number) + invoice_code + cost_center))
          continue; 
        InvoiceLedgerInfoVO invoiceLedgerInfoSaveVO = new InvoiceLedgerInfoVO();
        invoiceLedgerInfoSaveVO.setSource_type(SourceType.SourceType_JMS.getEnumValue().getValue());
        invoiceLedgerInfoSaveVO.setSource_billno(receivableBillVO.getDef10());
        invoiceLedgerInfoSaveVO.setArrival_ticket_state(ArrivalTicketState.ArrivalTicketState_已到票.getEnumValue().getValue());
        invoiceLedgerInfoSaveVO.setIs_arrival_ticket(UFBoolean.FALSE);
        invoiceLedgerInfoSaveVO.setInvoice_auth_type(InvoiceAuthType.InvoiceAuthType_待认证.getEnumValue().getValue());
        invoiceLedgerInfoSaveVO.setBilltype("FPRZFPTZ");
        invoiceLedgerInfoSaveVO.setTranstypepk(ydpBillPk);
        invoiceLedgerInfoSaveVO.setTranstype("FPRZFPTZ-Cxx-005");
        invoiceLedgerInfoSaveVO.setPk_group(receivableBillVO.getPk_group());
        invoiceLedgerInfoSaveVO.setPk_org(receivableBillVO.getPk_org());
        invoiceLedgerInfoSaveVO.setPk_org_v(receivableBillVO.getPk_org_v());
        invoiceLedgerInfoSaveVO.setNc_source_type(NcSourceType.NcSourceType_应收单.getEnumValue().getValue());
        invoiceLedgerInfoSaveVO.setNc_source_billno(receivableBillVO.getBillno());
        invoiceLedgerInfoSaveVO.setCost_center(ysdInvoice.getCost_center());
        invoiceLedgerInfoSaveVO.setBuyer_taxno(ysdInvoice.getBuyer_taxno());
        invoiceLedgerInfoSaveVO.setInvoice_code(ysdInvoice.getInvoice_code());
        invoiceLedgerInfoSaveVO.setInvoice_number(ysdInvoice.getInvoice_number());
        invoiceLedgerInfoSaveVO.setTax(ysdInvoice.getTax());
        invoiceLedgerInfoSaveVO.setTax_exclusive(ysdInvoice.getTax_exclusive());
        invoiceLedgerInfoSaveVO.setTotal_price_with_tax(ysdInvoice.getTotal_price_with_tax());
        invoiceLedgerInfoSaveVO.setInvoice_date(ysdInvoice.getInvoice_date());
        invoiceLedgerInfoSaveVO.setThe_seller(supplier);
        if (StringUtils.isNotBlank(ysdInvoice.getInvoice_type())) {
          String nccInvoiceType = (String)this.hyPubBO.findColValue("sscivm_invoice_type_map", "ncc_invoice_type", " oa_invoice_type = '" + ysdInvoice.getInvoice_type() + "'");
          invoiceLedgerInfoSaveVO.setInvoice_type(nccInvoiceType);
        } 
        invoiceLedgerInfoSaveVO.setApprovestatus(Integer.valueOf(BillStatusEnum.APPROVED.toIntValue()));
        invoiceLedgerInfoSaveVO.setStatus(2);
        AggInvoiceLedgerInfoVO aggInvoiceLedgerInfoVO = new AggInvoiceLedgerInfoVO();
        aggInvoiceLedgerInfoVO.setParent((ISuperVO)invoiceLedgerInfoSaveVO);
        saveVOList.add(aggInvoiceLedgerInfoVO);
      } 
    } 
    return saveVOList;
  }
  
  private List<AggInvoiceLedgerInfoVO> yfdOAAndJms(String begintime, String endtime) throws BusinessException {
    List<AggInvoiceLedgerInfoVO> saveVOList = Lists.newArrayList();
    IArapPayableBillQueryService iArapPayableBillQueryService = getIArapPayableBillQueryService();
    AggPayableBillVO[] yfdArr = iArapPayableBillQueryService.queryVOsByWhere(" DR = 0 and pk_tradetype in('F1-Cxx-YFGZ', 'F1-Cxx-YFJS', 'F1-Cxx-YFMD', 'F1-Cxx-01', 'F1-Cxx-02', 'F1-Cxx-03', 'F1-Cxx-04', 'F1-Cxx-05', 'F1-Cxx-06', 'F1-Cxx-07', 'F1-Cxx-08', 'F1-Cxx-09', 'F1-Cxx-10') and BILLDATE >= '" + begintime + "' and BILLDATE <= '" + endtime + "'");
    if (Objects.isNull(yfdArr) || yfdArr.length <= 0)
      return Lists.newArrayList(); 
    List<AggPayableBillVO> yfdList = Arrays.asList(yfdArr);
    String fkdInvoiceSql = "select * from arap_bill_invoice where DR = 0 AND SOURCE_NO IN (SELECT pk_payablebill FROM ap_payablebill WHERE DR = 0 and pk_tradetype in('F1-Cxx-YFGZ', 'F1-Cxx-YFJS', 'F1-Cxx-YFMD', 'F1-Cxx-01', 'F1-Cxx-02', 'F1-Cxx-03', 'F1-Cxx-04', 'F1-Cxx-05', 'F1-Cxx-06', 'F1-Cxx-07', 'F1-Cxx-08', 'F1-Cxx-09', 'F1-Cxx-10') and BILLDATE >= '" + begintime + "' and BILLDATE <= '" + endtime + "')";
    List<ArapBillInvoiceVO> yfdInvoiceList = (List<ArapBillInvoiceVO>)this.baseDAO.executeQuery(fkdInvoiceSql, (ResultSetProcessor)new BeanListProcessor(ArapBillInvoiceVO.class));
    if (CollectionUtils.isEmpty(yfdInvoiceList))
      return Lists.newArrayList(); 
    Map<String, List<ArapBillInvoiceVO>> sourceNoListMap = (Map<String, List<ArapBillInvoiceVO>>)yfdInvoiceList.stream().collect(Collectors.groupingBy(ArapBillInvoiceVO::getSource_no));
    int count = 0;
    List<String> existInvoiceMap = Lists.newArrayList();
    StringBuilder distinctInvoiceSql = new StringBuilder();
    for (int i = 0; i < yfdInvoiceList.size(); i++) {
      ArapBillInvoiceVO billInvoiceVO = yfdInvoiceList.get(i);
      if (!Objects.isNull(billInvoiceVO)) {
        String invoiceNumber = StringUtils.isNotBlank(billInvoiceVO.getInvoice_number()) ? billInvoiceVO.getInvoice_number() : "";
        String invoiceCode = StringUtils.isNotBlank(billInvoiceVO.getInvoice_code()) ? billInvoiceVO.getInvoice_code() : "~";
        String costCenter = billInvoiceVO.getCost_center();
        if (StringUtils.isNotBlank(invoiceNumber) || StringUtils.isNotBlank(invoiceCode)) {
          distinctInvoiceSql.append(" ( ");
          distinctInvoiceSql.append(" invoice_number = '").append(invoiceNumber).append("' ");
          distinctInvoiceSql.append(" and NVL(invoice_code, '~') = '").append(invoiceCode).append("' ");
          distinctInvoiceSql.append(" and cost_center = '").append(costCenter).append("' ");
          distinctInvoiceSql.append(" ) ");
          if (i < yfdInvoiceList.size() - 1)
            distinctInvoiceSql.append(" or "); 
        } 
        count++;
        if (count == 1000 || i == yfdInvoiceList.size() - 1) {
          if (distinctInvoiceSql.toString().endsWith("or "))
            distinctInvoiceSql.delete(distinctInvoiceSql.length() - 4, distinctInvoiceSql.length()); 
          if (StringUtils.isBlank(distinctInvoiceSql))
            distinctInvoiceSql.append(" 1 != 1 "); 
          distinctInvoiceSql.append(" AND DR = 0 ");
          List<String> newExistInvoiceMap = getExistInvoice(distinctInvoiceSql.toString(), false);
          if (CollectionUtils.isNotEmpty(newExistInvoiceMap))
            existInvoiceMap.addAll(newExistInvoiceMap); 
          count = 0;
          distinctInvoiceSql = new StringBuilder();
        } 
      } 
    } 
    String ydpBillPk = (String)this.hyPubBO.findColValue("BD_BILLTYPE", "PK_BILLTYPEID", " PK_BILLTYPECODE = 'FPRZFPTZ-Cxx-001'");
    for (AggPayableBillVO yfd : yfdList) {
      if (Objects.isNull(yfd))
        continue; 
      PayableBillVO payableBillVO = (PayableBillVO)yfd.getParentVO();
      if (Objects.isNull(payableBillVO))
        continue; 
      PayableBillItemVO[] payableBillItemVOS = (PayableBillItemVO[])yfd.getChildrenVO();
      if (payableBillItemVOS == null || payableBillItemVOS.length <= 0)
        continue; 
      String supplier = payableBillItemVOS[0].getSupplier();
      List<ArapBillInvoiceVO> sourceNoList = sourceNoListMap.get(payableBillVO.getPk_payablebill());
      if (CollectionUtils.isEmpty(sourceNoList))
        continue; 
      for (ArapBillInvoiceVO yfdInvoice : sourceNoList) {
        if (Objects.isNull(yfdInvoice))
          continue; 
        String invoice_number = StringUtils.isNotBlank(yfdInvoice.getInvoice_number()) ? yfdInvoice.getInvoice_number() : "";
        String invoice_code = StringUtils.isNotBlank(yfdInvoice.getInvoice_code()) ? yfdInvoice.getInvoice_code() : "";
        String cost_center = StringUtils.isNotBlank(yfdInvoice.getCost_center()) ? yfdInvoice.getCost_center() : "";
        if (CollectionUtils.isNotEmpty(existInvoiceMap) && existInvoiceMap.contains(String.valueOf(invoice_number) + invoice_code + cost_center))
          continue; 
        InvoiceLedgerInfoVO invoiceLedgerInfoSaveVO = new InvoiceLedgerInfoVO();
        if ("F1-Cxx-YFGZ".equals(payableBillVO.getPk_tradetype()) || "F1-Cxx-YFJS".equals(payableBillVO.getPk_tradetype()) || 
          "F1-Cxx-YFMD".equals(payableBillVO.getPk_tradetype())) {
          invoiceLedgerInfoSaveVO.setSource_type(SourceType.SourceType_JMS.getEnumValue().getValue());
          invoiceLedgerInfoSaveVO.setSource_billno(payableBillVO.getDef10());
        } else if (isWdp(payableBillVO.getPk_tradetype())) {
          invoiceLedgerInfoSaveVO.setSource_type(StringUtils.isBlank(payableBillVO.getDef19()) ? "" : SourceType.SourceType_OA.getEnumValue().getValue());
          invoiceLedgerInfoSaveVO.setSource_billno(payableBillVO.getDef19());
        } 
        invoiceLedgerInfoSaveVO.setArrival_ticket_state(ArrivalTicketState.ArrivalTicketState_未到票.getEnumValue().getValue());
        invoiceLedgerInfoSaveVO.setIs_arrival_ticket(UFBoolean.FALSE);
        invoiceLedgerInfoSaveVO.setInvoice_auth_type(InvoiceAuthType.InvoiceAuthType_待认证.getEnumValue().getValue());
        invoiceLedgerInfoSaveVO.setBilltype("FPRZFPTZ");
        invoiceLedgerInfoSaveVO.setTranstypepk(ydpBillPk);
        invoiceLedgerInfoSaveVO.setTranstype("FPRZFPTZ-Cxx-001");
        invoiceLedgerInfoSaveVO.setPk_group(payableBillVO.getPk_group());
        invoiceLedgerInfoSaveVO.setPk_org(payableBillVO.getPk_org());
        invoiceLedgerInfoSaveVO.setPk_org_v(payableBillVO.getPk_org_v());
        invoiceLedgerInfoSaveVO.setNc_source_type(NcSourceType.NcSourceType_应付单.getEnumValue().getValue());
        invoiceLedgerInfoSaveVO.setNc_source_billno(payableBillVO.getBillno());
        invoiceLedgerInfoSaveVO.setCost_center(yfdInvoice.getCost_center());
        invoiceLedgerInfoSaveVO.setBuyer_taxno(yfdInvoice.getBuyer_taxno());
        invoiceLedgerInfoSaveVO.setInvoice_code(yfdInvoice.getInvoice_code());
        invoiceLedgerInfoSaveVO.setInvoice_number(yfdInvoice.getInvoice_number());
        invoiceLedgerInfoSaveVO.setTax(yfdInvoice.getTax());
        invoiceLedgerInfoSaveVO.setTax_exclusive(yfdInvoice.getTax_exclusive());
        invoiceLedgerInfoSaveVO.setTotal_price_with_tax(yfdInvoice.getTotal_price_with_tax());
        invoiceLedgerInfoSaveVO.setInvoice_date(yfdInvoice.getInvoice_date());
        invoiceLedgerInfoSaveVO.setThe_seller(supplier);
        if (StringUtils.isNotBlank(yfdInvoice.getInvoice_type())) {
          String nccInvoiceType = (String)this.hyPubBO.findColValue("sscivm_invoice_type_map", "ncc_invoice_type", " oa_invoice_type = '" + yfdInvoice.getInvoice_type() + "'");
          invoiceLedgerInfoSaveVO.setInvoice_type(nccInvoiceType);
        } 
        invoiceLedgerInfoSaveVO.setApprovestatus(Integer.valueOf(BillStatusEnum.FREE.toIntValue()));
        invoiceLedgerInfoSaveVO.setStatus(2);
        AggInvoiceLedgerInfoVO aggInvoiceLedgerInfoVO = new AggInvoiceLedgerInfoVO();
        aggInvoiceLedgerInfoVO.setParent((ISuperVO)invoiceLedgerInfoSaveVO);
        saveVOList.add(aggInvoiceLedgerInfoVO);
      } 
    } 
    return saveVOList;
  }
  
  private List<AggInvoiceLedgerInfoVO> yfdOa(String begintime, String endtime) throws BusinessException {
    List<AggInvoiceLedgerInfoVO> saveVOList = Lists.newArrayList();
    IArapPayableBillQueryService iArapPayableBillQueryService = getIArapPayableBillQueryService();
    AggPayableBillVO[] yfdArr = iArapPayableBillQueryService.queryVOsByWhere(" DR = 0 and pk_tradetype in('F1-Cxx-DGYF', 'F1-Cxx-DGYFHX') AND APPROVEDATE >= '" + begintime + "' and APPROVEDATE <= '" + endtime + "' ");
    if (Objects.isNull(yfdArr) || yfdArr.length <= 0)
      return Lists.newArrayList(); 
    List<AggPayableBillVO> yfdList = Arrays.asList(yfdArr);
    List<PayableBillItemVO> payableBillItemVOList = Lists.newArrayList();
    List<Map<String, String>> billVoucherMapList = Lists.newArrayList();
    int voucherCount = 0;
    StringBuilder voucherSql = new StringBuilder(" select NVL(SUBSTR(fr.src_relationid, 1, INSTR(fr.src_relationid, '_', 1, 1) - 1), fr.src_relationid) bill_no, gv.num voucherno, CONCAT(gv.YEAR, gv.period) period from fip_relation fr inner join gl_voucher gv on fr.DES_RELATIONID = gv.pk_voucher where fr.DR = 0 and gv.DR = 0 and ( ");
    for (int i = 0; i < yfdArr.length; i++) {
      AggPayableBillVO aggPayableBillVO = yfdArr[i];
      if (!Objects.isNull(aggPayableBillVO)) {
        payableBillItemVOList.addAll((aggPayableBillVO.getChildrenVO() != null && (aggPayableBillVO.getChildrenVO()).length >= 1) ? Arrays.<PayableBillItemVO>asList((PayableBillItemVO[])aggPayableBillVO.getChildrenVO()) : Lists.newArrayList());
        voucherSql.append(" fr.src_relationid like '").append(aggPayableBillVO.getParentVO().getPrimaryKey()).append("%'");
        if (i < yfdArr.length - 1)
          voucherSql.append(" or "); 
        voucherCount++;
        if (voucherCount == 1000 || i == yfdArr.length - 1) {
          if (voucherSql.toString().endsWith("or "))
            voucherSql.delete(voucherSql.length() - 4, voucherSql.length()); 
          voucherSql.append(" ) ");
          List<Map<String, String>> newBillVoucherMapList = (List<Map<String, String>>)this.baseDAO.executeQuery(voucherSql.toString(), (ResultSetProcessor)new MapListProcessor());
          if (CollectionUtils.isNotEmpty(newBillVoucherMapList))
            billVoucherMapList.addAll(newBillVoucherMapList); 
          voucherCount = 0;
          voucherSql = new StringBuilder(" select NVL(SUBSTR(fr.src_relationid, 1, INSTR(fr.src_relationid, '_', 1, 1) - 1), fr.src_relationid) bill_no, gv.num voucherno, CONCAT(gv.YEAR, gv.period) period from fip_relation fr inner join gl_voucher gv on fr.DES_RELATIONID = gv.pk_voucher where fr.DR = 0 and gv.DR = 0 and ( ");
        } 
      } 
    } 
    if (CollectionUtils.isEmpty(payableBillItemVOList))
      return Lists.newArrayList(); 
    if (CollectionUtils.isEmpty(billVoucherMapList))
      return Lists.newArrayList(); 
    Map<String, Map<String, String>> billNoMapMap = (Map<String, Map<String, String>>)billVoucherMapList.stream().collect(Collectors.groupingBy(a -> (String)a.get("bill_no"), Collectors.collectingAndThen(Collectors.toList(), value -> (Map)value.get(0))));
    int count = 0;
    List<String> existInvoiceMap = Lists.newArrayList();
    StringBuilder distinctInvoiceSql = new StringBuilder();
    for (int j = 0; j < payableBillItemVOList.size(); j++) {
      PayableBillItemVO payableBillItemVO = payableBillItemVOList.get(j);
      if (!Objects.isNull(payableBillItemVO)) {
        Map<String, String> billNoMap = billNoMapMap.get(payableBillItemVO.getPk_payablebill());
        if (!Objects.isNull(billNoMap)) {
          String invoiceNumber = StringUtils.isNotBlank(payableBillItemVO.getDef80()) ? ("null".equals(payableBillItemVO.getDef80()) ? "" : payableBillItemVO.getDef80()) : "";
          String invoiceCode = StringUtils.isNotBlank(payableBillItemVO.getDef28()) ? ("null".equals(payableBillItemVO.getDef28()) ? "~" : payableBillItemVO.getDef28()) : "~";
          String costCenter = StringUtils.isNotBlank(payableBillItemVO.getDef2()) ? ("null".equals(payableBillItemVO.getDef2()) ? "" : payableBillItemVO.getDef2()) : "";
          String voucherno = String.valueOf(billNoMap.get("voucherno"));
          if (StringUtils.isNotBlank(invoiceNumber) || StringUtils.isNotBlank(invoiceCode)) {
            distinctInvoiceSql.append(" ( ");
            distinctInvoiceSql.append(" invoice_number = '").append(invoiceNumber).append("' ");
            distinctInvoiceSql.append(" and NVL(invoice_code, '~') = '").append(invoiceCode).append("' ");
            distinctInvoiceSql.append(" and cost_center = '").append(costCenter).append("' ");
            distinctInvoiceSql.append(" and voucher_no = '").append(voucherno).append("' ");
            distinctInvoiceSql.append(" ) ");
            if (j < payableBillItemVOList.size() - 1)
              distinctInvoiceSql.append(" or "); 
          } 
          count++;
          if (count == 1000 || j == payableBillItemVOList.size() - 1) {
            if (distinctInvoiceSql.toString().endsWith("or "))
              distinctInvoiceSql.delete(distinctInvoiceSql.length() - 4, distinctInvoiceSql.length()); 
            if (StringUtils.isBlank(distinctInvoiceSql))
              distinctInvoiceSql.append(" 1 != 1 "); 
            distinctInvoiceSql.append(" AND DR = 0 ");
            List<String> newExistInvoiceMap = getExistInvoice(distinctInvoiceSql.toString(), true);
            if (CollectionUtils.isNotEmpty(newExistInvoiceMap))
              existInvoiceMap.addAll(newExistInvoiceMap); 
            count = 0;
            distinctInvoiceSql = new StringBuilder();
          } 
        } 
      } 
    } 
    String ydpBillPk = (String)this.hyPubBO.findColValue("BD_BILLTYPE", "PK_BILLTYPEID", " PK_BILLTYPECODE = 'FPRZFPTZ-Cxx-001'");
    for (AggPayableBillVO yfd : yfdList) {
      if (Objects.isNull(yfd))
        continue; 
      PayableBillVO payableBillVO = (PayableBillVO)yfd.getParentVO();
      if (Objects.isNull(payableBillVO))
        continue; 
      PayableBillItemVO[] payableBillItemVOS = (PayableBillItemVO[])yfd.getChildrenVO();
      if (payableBillItemVOS == null || payableBillItemVOS.length <= 0)
        continue; 
      Map<String, String> billNoMap = billNoMapMap.get(payableBillVO.getPk_payablebill());
      if (Objects.isNull(billNoMap))
        continue; 
      String voucherno = String.valueOf(billNoMap.get("voucherno"));
      if (StringUtils.isBlank(voucherno))
        continue; 
      String period = billNoMap.get("period");
      byte b;
      int k;
      PayableBillItemVO[] arrayOfPayableBillItemVO1;
      for (k = (arrayOfPayableBillItemVO1 = payableBillItemVOS).length, b = 0; b < k; ) {
        PayableBillItemVO payableBillItemVO = arrayOfPayableBillItemVO1[b];
        if (!Objects.isNull(payableBillItemVO)) {
          String invoice_number = StringUtils.isNotBlank(payableBillItemVO.getDef80()) ? payableBillItemVO.getDef80() : "";
          String invoice_code = StringUtils.isNotBlank(payableBillItemVO.getDef28()) ? payableBillItemVO.getDef28() : "";
          String cost_center = StringUtils.isNotBlank(payableBillItemVO.getDef2()) ? payableBillItemVO.getDef2() : "";
          if (!CollectionUtils.isNotEmpty(existInvoiceMap) || !existInvoiceMap.contains(String.valueOf(invoice_number) + invoice_code + cost_center + voucherno)) {
            InvoiceLedgerInfoVO invoiceLedgerInfoSaveVO = new InvoiceLedgerInfoVO();
            invoiceLedgerInfoSaveVO.setArrival_ticket_state(ArrivalTicketState.ArrivalTicketState_已到票.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setIs_arrival_ticket(UFBoolean.FALSE);
            invoiceLedgerInfoSaveVO.setInvoice_auth_type(InvoiceAuthType.InvoiceAuthType_待认证.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setSource_type(SourceType.SourceType_OA.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setBilltype("FPRZFPTZ");
            invoiceLedgerInfoSaveVO.setTranstypepk(ydpBillPk);
            invoiceLedgerInfoSaveVO.setTranstype("FPRZFPTZ-Cxx-001");
            invoiceLedgerInfoSaveVO.setSource_billno(payableBillVO.getDef19());
            invoiceLedgerInfoSaveVO.setPk_group(payableBillVO.getPk_group());
            invoiceLedgerInfoSaveVO.setPk_org(payableBillVO.getPk_org());
            invoiceLedgerInfoSaveVO.setPk_org_v(payableBillVO.getPk_org_v());
            invoiceLedgerInfoSaveVO.setCost_center(payableBillVO.getDef2());
            invoiceLedgerInfoSaveVO.setNc_source_type(NcSourceType.NcSourceType_应付单.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setNc_source_billno(payableBillVO.getBillno());
            invoiceLedgerInfoSaveVO.setVoucher_no(voucherno);
            invoiceLedgerInfoSaveVO.setPeriod(period);
            invoiceLedgerInfoSaveVO.setBuyer_taxno(payableBillItemVO.getDef32());
            invoiceLedgerInfoSaveVO.setInvoice_code(payableBillItemVO.getDef28());
            invoiceLedgerInfoSaveVO.setInvoice_number(payableBillItemVO.getDef80());
            invoiceLedgerInfoSaveVO.setTax(payableBillItemVO.getLocal_tax_cr());
            invoiceLedgerInfoSaveVO.setTax_exclusive(payableBillItemVO.getLocal_notax_cr());
            invoiceLedgerInfoSaveVO.setTotal_price_with_tax(payableBillItemVO.getLocal_money_cr());
            invoiceLedgerInfoSaveVO.setInvoice_date(StringUtils.isNotBlank(payableBillItemVO.getDef33()) ? new UFDate(payableBillItemVO.getDef33()) : null);
            invoiceLedgerInfoSaveVO.setThe_seller(payableBillItemVO.getSupplier());
            if (StringUtils.isNotBlank(payableBillItemVO.getDef27())) {
              String nccInvoiceType = (String)this.hyPubBO.findColValue("sscivm_invoice_type_map", "ncc_invoice_type", " oa_invoice_type = '" + payableBillItemVO.getDef27() + "'");
              invoiceLedgerInfoSaveVO.setInvoice_type(nccInvoiceType);
            } 
            invoiceLedgerInfoSaveVO.setApprovestatus(Integer.valueOf(BillStatusEnum.APPROVED.toIntValue()));
            invoiceLedgerInfoSaveVO.setStatus(2);
            AggInvoiceLedgerInfoVO aggInvoiceLedgerInfoVO = new AggInvoiceLedgerInfoVO();
            aggInvoiceLedgerInfoVO.setParent((ISuperVO)invoiceLedgerInfoSaveVO);
            saveVOList.add(aggInvoiceLedgerInfoVO);
          } 
        } 
        b++;
      } 
    } 
    return saveVOList;
  }
  
  private List<AggInvoiceLedgerInfoVO> fkd(String begintime, String endtime) throws BusinessException {
    List<AggInvoiceLedgerInfoVO> saveVOList = Lists.newArrayList();
    IArapPayBillQueryService iArapPayBillQueryService = getIArapPayBillQueryService();
    AggPayBillVO[] fkdArr = iArapPayBillQueryService.queryBillsByWhereSQL(" DR = 0  and DEF19 is not null and DEF19 <> '~' AND BILLDATE >= '" + begintime + "' and BILLDATE <= '" + endtime + "' ");
    if (Objects.isNull(fkdArr) || fkdArr.length <= 0)
      return Lists.newArrayList(); 
    String fkdInvoiceSql = "select * from arap_bill_invoice where DR = 0 AND SOURCE_NO IN (select pk_paybill from ap_paybill WHERE DR = 0  and DEF19 is not null and DEF19 <> '~' AND BILLDATE >= '" + begintime + "' and BILLDATE <= '" + endtime + "' )";
    List<ArapBillInvoiceVO> fkdInvoiceList = (List<ArapBillInvoiceVO>)this.baseDAO.executeQuery(fkdInvoiceSql, (ResultSetProcessor)new BeanListProcessor(ArapBillInvoiceVO.class));
    if (CollectionUtils.isEmpty(fkdInvoiceList))
      return Lists.newArrayList(); 
    Map<String, List<ArapBillInvoiceVO>> sourceNoListMap = (Map<String, List<ArapBillInvoiceVO>>)fkdInvoiceList.stream().collect(Collectors.groupingBy(ArapBillInvoiceVO::getSource_no));
    int count = 0;
    List<String> existInvoiceMap = Lists.newArrayList();
    StringBuilder distinctInvoiceSql = new StringBuilder();
    for (int i = 0; i < fkdInvoiceList.size(); i++) {
      ArapBillInvoiceVO billInvoiceVO = fkdInvoiceList.get(i);
      if (!Objects.isNull(billInvoiceVO)) {
        String invoiceNumber = StringUtils.isNotBlank(billInvoiceVO.getInvoice_number()) ? billInvoiceVO.getInvoice_number() : "";
        String invoiceCode = StringUtils.isNotBlank(billInvoiceVO.getInvoice_code()) ? billInvoiceVO.getInvoice_code() : "~";
        String costCenter = billInvoiceVO.getCost_center();
        if (StringUtils.isNotBlank(invoiceNumber) || StringUtils.isNotBlank(invoiceCode)) {
          distinctInvoiceSql.append(" ( ");
          distinctInvoiceSql.append(" invoice_number = '").append(invoiceNumber).append("' ");
          distinctInvoiceSql.append(" and NVL(invoice_code, '~') = '").append(invoiceCode).append("' ");
          distinctInvoiceSql.append(" and cost_center = '").append(costCenter).append("' ");
          distinctInvoiceSql.append(" ) ");
          if (i < fkdInvoiceList.size() - 1)
            distinctInvoiceSql.append(" or "); 
        } 
        count++;
        if (count == 1000 || i == fkdInvoiceList.size() - 1) {
          if (distinctInvoiceSql.toString().endsWith("or "))
            distinctInvoiceSql.delete(distinctInvoiceSql.length() - 4, distinctInvoiceSql.length()); 
          if (StringUtils.isBlank(distinctInvoiceSql))
            distinctInvoiceSql.append(" 1 != 1 "); 
          distinctInvoiceSql.append(" AND DR = 0 ");
          List<String> newExistInvoiceMap = getExistInvoice(distinctInvoiceSql.toString(), false);
          if (CollectionUtils.isNotEmpty(newExistInvoiceMap))
            existInvoiceMap.addAll(newExistInvoiceMap); 
          count = 0;
          distinctInvoiceSql = new StringBuilder();
        } 
      } 
    } 
    String ydpBillPk = (String)this.hyPubBO.findColValue("BD_BILLTYPE", "PK_BILLTYPEID", " PK_BILLTYPECODE = 'FPRZFPTZ-Cxx-001'");
    byte b;
    int j;
    AggPayBillVO[] arrayOfAggPayBillVO1;
    for (j = (arrayOfAggPayBillVO1 = fkdArr).length, b = 0; b < j; ) {
      AggPayBillVO fkd = arrayOfAggPayBillVO1[b];
      if (!Objects.isNull(fkd)) {
        PayBillVO payBillVO = (PayBillVO)fkd.getParentVO();
        if (!Objects.isNull(payBillVO)) {
          PayBillItemVO[] payBillItemVOS = (PayBillItemVO[])fkd.getChildrenVO();
          if (payBillItemVOS != null && payBillItemVOS.length > 0) {
            String supplier = payBillItemVOS[0].getSupplier();
            List<ArapBillInvoiceVO> sourceNoList = sourceNoListMap.get(payBillVO.getPk_paybill());
            if (!CollectionUtils.isEmpty(sourceNoList))
              for (ArapBillInvoiceVO fkdInvoice : sourceNoList) {
                if (Objects.isNull(fkdInvoice))
                  continue; 
                String invoice_number = StringUtils.isNotBlank(fkdInvoice.getInvoice_number()) ? fkdInvoice.getInvoice_number() : "";
                String invoice_code = StringUtils.isNotBlank(fkdInvoice.getInvoice_code()) ? fkdInvoice.getInvoice_code() : "";
                String cost_center = StringUtils.isNotBlank(fkdInvoice.getCost_center()) ? fkdInvoice.getCost_center() : "";
                if (CollectionUtils.isNotEmpty(existInvoiceMap) && existInvoiceMap.contains(String.valueOf(invoice_number) + invoice_code + cost_center))
                  continue; 
                InvoiceLedgerInfoVO invoiceLedgerInfoSaveVO = new InvoiceLedgerInfoVO();
                invoiceLedgerInfoSaveVO.setArrival_ticket_state(ArrivalTicketState.ArrivalTicketState_未到票.getEnumValue().getValue());
                invoiceLedgerInfoSaveVO.setIs_arrival_ticket(UFBoolean.FALSE);
                invoiceLedgerInfoSaveVO.setInvoice_auth_type(InvoiceAuthType.InvoiceAuthType_待认证.getEnumValue().getValue());
                invoiceLedgerInfoSaveVO.setSource_type(SourceType.SourceType_OA.getEnumValue().getValue());
                invoiceLedgerInfoSaveVO.setBilltype("FPRZFPTZ");
                invoiceLedgerInfoSaveVO.setTranstypepk(ydpBillPk);
                invoiceLedgerInfoSaveVO.setTranstype("FPRZFPTZ-Cxx-001");
                invoiceLedgerInfoSaveVO.setSource_billno(payBillVO.getDef19());
                invoiceLedgerInfoSaveVO.setPk_group(payBillVO.getPk_group());
                invoiceLedgerInfoSaveVO.setPk_org(payBillVO.getPk_org());
                invoiceLedgerInfoSaveVO.setPk_org_v(payBillVO.getPk_org_v());
                invoiceLedgerInfoSaveVO.setNc_source_type(NcSourceType.NcSourceType_付款单.getEnumValue().getValue());
                invoiceLedgerInfoSaveVO.setNc_source_billno(payBillVO.getBillno());
                invoiceLedgerInfoSaveVO.setCost_center(fkdInvoice.getCost_center());
                invoiceLedgerInfoSaveVO.setBuyer_taxno(fkdInvoice.getBuyer_taxno());
                invoiceLedgerInfoSaveVO.setInvoice_code(fkdInvoice.getInvoice_code());
                invoiceLedgerInfoSaveVO.setInvoice_number(fkdInvoice.getInvoice_number());
                invoiceLedgerInfoSaveVO.setTax(fkdInvoice.getTax());
                invoiceLedgerInfoSaveVO.setTax_exclusive(fkdInvoice.getTax_exclusive());
                invoiceLedgerInfoSaveVO.setTotal_price_with_tax(fkdInvoice.getTotal_price_with_tax());
                invoiceLedgerInfoSaveVO.setInvoice_date(fkdInvoice.getInvoice_date());
                invoiceLedgerInfoSaveVO.setThe_seller(supplier);
                if (StringUtils.isNotBlank(fkdInvoice.getInvoice_type())) {
                  String nccInvoiceType = (String)this.hyPubBO.findColValue("sscivm_invoice_type_map", "ncc_invoice_type", " oa_invoice_type = '" + fkdInvoice.getInvoice_type() + "'");
                  invoiceLedgerInfoSaveVO.setInvoice_type(nccInvoiceType);
                } 
                invoiceLedgerInfoSaveVO.setApprovestatus(Integer.valueOf(BillStatusEnum.FREE.toIntValue()));
                invoiceLedgerInfoSaveVO.setStatus(2);
                AggInvoiceLedgerInfoVO aggInvoiceLedgerInfoVO = new AggInvoiceLedgerInfoVO();
                aggInvoiceLedgerInfoVO.setParent((ISuperVO)invoiceLedgerInfoSaveVO);
                saveVOList.add(aggInvoiceLedgerInfoVO);
              }  
          } 
        } 
      } 
      b++;
    } 
    return saveVOList;
  }
  
  private List<AggInvoiceLedgerInfoVO> bxd(String begintime, String endtime) throws BusinessException {
    List<AggInvoiceLedgerInfoVO> saveVOList = Lists.newArrayList();
    IBXBillPrivate ibxBillPrivate = getIBXBillPrivate();
    List<JKBXVO> bxdList = ibxBillPrivate.queryVOsByWhereSql(" where DR = 0 AND DJLXBM IN('264X-Cxx-DSBXD', '264X-Cxx-DGBXD', '264X-Cxx-YFKHXD') AND SHRQ >= '" + begintime + "' AND SHRQ <= '" + endtime + "' ", null);
    if (CollectionUtils.isEmpty(bxdList))
      return Lists.newArrayList(); 
    List<BXBusItemVO> bxBusItemVOList = Lists.newArrayList();
    List<Map<String, String>> billVoucherMapList = Lists.newArrayList();
    int voucherCount = 0;
    StringBuilder voucherSql = new StringBuilder(" select NVL(SUBSTR(fr.src_relationid, 1, INSTR(fr.src_relationid, '_', 1, 1) - 1), fr.src_relationid) bill_no, gv.num voucherno, CONCAT(gv.YEAR, gv.period) period from fip_relation fr inner join gl_voucher gv on fr.DES_RELATIONID = gv.pk_voucher where fr.DR = 0 and gv.DR = 0 and ( ");
    for (int i = 0; i < bxdList.size(); i++) {
      JKBXVO jkbxvo = bxdList.get(i);
      if (!Objects.isNull(jkbxvo)) {
        bxBusItemVOList.addAll((jkbxvo.getChildrenVO() != null && (jkbxvo.getChildrenVO()).length >= 1) ? Arrays.<BXBusItemVO>asList(jkbxvo.getChildrenVO()) : Lists.newArrayList());
        voucherSql.append(" fr.src_relationid like '").append(jkbxvo.getParentVO().getPk_jkbx()).append("%'");
        if (i < bxdList.size() - 1)
          voucherSql.append(" or "); 
        voucherCount++;
        if (voucherCount == 1000 || i == bxdList.size() - 1) {
          if (voucherSql.toString().endsWith("or "))
            voucherSql.delete(voucherSql.length() - 4, voucherSql.length()); 
          voucherSql.append(" ) ");
          List<Map<String, String>> newBillVoucherMapList = (List<Map<String, String>>)this.baseDAO.executeQuery(voucherSql.toString(), (ResultSetProcessor)new MapListProcessor());
          if (CollectionUtils.isNotEmpty(newBillVoucherMapList))
            billVoucherMapList.addAll(newBillVoucherMapList); 
          voucherCount = 0;
          voucherSql = new StringBuilder(" select NVL(SUBSTR(fr.src_relationid, 1, INSTR(fr.src_relationid, '_', 1, 1) - 1), fr.src_relationid) bill_no, gv.num voucherno, CONCAT(gv.YEAR, gv.period) period from fip_relation fr inner join gl_voucher gv on fr.DES_RELATIONID = gv.pk_voucher where fr.DR = 0 and gv.DR = 0 and ( ");
        } 
      } 
    } 
    if (CollectionUtils.isEmpty(bxBusItemVOList))
      return Lists.newArrayList(); 
    if (CollectionUtils.isEmpty(billVoucherMapList))
      return Lists.newArrayList(); 
    Map<String, Map<String, String>> billNoMapMap = (Map<String, Map<String, String>>)billVoucherMapList.stream().collect(Collectors.groupingBy(a -> (String)a.get("bill_no"), Collectors.collectingAndThen(Collectors.toList(), value -> (Map)value.get(0))));
    int count = 0;
    List<String> existInvoiceMap = Lists.newArrayList();
    StringBuilder distinctInvoiceSql = new StringBuilder();
    for (int j = 0; j < bxBusItemVOList.size(); j++) {
      BXBusItemVO bxBusItemVO = bxBusItemVOList.get(j);
      if (!Objects.isNull(bxBusItemVO)) {
        Map<String, String> billNoMap = billNoMapMap.get(bxBusItemVO.getPk_jkbx());
        if (!Objects.isNull(billNoMap)) {
          String invoiceNumber = StringUtils.isNotBlank(bxBusItemVO.getFphm()) ? ("null".equals(bxBusItemVO.getFphm()) ? "" : bxBusItemVO.getFphm()) : "";
          String invoiceCode = StringUtils.isNotBlank(bxBusItemVO.getFpdm()) ? ("null".equals(bxBusItemVO.getFpdm()) ? "~" : bxBusItemVO.getFpdm()) : "~";
          String costCenter = StringUtils.isNotBlank(bxBusItemVO.getDefitem46()) ? ("null".equals(bxBusItemVO.getDefitem46()) ? "" : bxBusItemVO.getDefitem46()) : "";
          String voucherno = String.valueOf(billNoMap.get("voucherno"));
          if (StringUtils.isNotBlank(invoiceNumber) || StringUtils.isNotBlank(invoiceCode)) {
            distinctInvoiceSql.append(" ( ");
            distinctInvoiceSql.append(" invoice_number = '").append(invoiceNumber).append("' ");
            distinctInvoiceSql.append(" and NVL(invoice_code, '~') = '").append(invoiceCode).append("' ");
            distinctInvoiceSql.append(" and cost_center = '").append(costCenter).append("' ");
            distinctInvoiceSql.append(" and voucher_no = '").append(voucherno).append("' ");
            distinctInvoiceSql.append(" ) ");
            if (j < bxBusItemVOList.size() - 1)
              distinctInvoiceSql.append(" or "); 
          } 
          count++;
          if (count == 1000 || j == bxBusItemVOList.size() - 1) {
            if (distinctInvoiceSql.toString().endsWith("or "))
              distinctInvoiceSql.delete(distinctInvoiceSql.length() - 4, distinctInvoiceSql.length()); 
            if (StringUtils.isBlank(distinctInvoiceSql))
              distinctInvoiceSql.append(" 1 != 1 "); 
            distinctInvoiceSql.append(" AND DR = 0 ");
            List<String> newExistInvoiceMap = getExistInvoice(distinctInvoiceSql.toString(), true);
            if (CollectionUtils.isNotEmpty(newExistInvoiceMap))
              existInvoiceMap.addAll(newExistInvoiceMap); 
            count = 0;
            distinctInvoiceSql = new StringBuilder();
          } 
        } 
      } 
    } 
    String ydpBillPk = (String)this.hyPubBO.findColValue("BD_BILLTYPE", "PK_BILLTYPEID", " PK_BILLTYPECODE = 'FPRZFPTZ-Cxx-001'");
    for (JKBXVO bxd : bxdList) {
      if (Objects.isNull(bxd))
        continue; 
      JKBXHeaderVO jkbxHeaderVO = bxd.getParentVO();
      if (Objects.isNull(jkbxHeaderVO))
        continue; 
      BXBusItemVO[] bxBusItemVOS = bxd.getChildrenVO();
      if (bxBusItemVOS == null || bxBusItemVOS.length <= 0)
        continue; 
      Map<String, String> billNoMap = billNoMapMap.get(jkbxHeaderVO.getPk_jkbx());
      if (Objects.isNull(billNoMap))
        continue; 
      String voucherno = String.valueOf(billNoMap.get("voucherno"));
      if (StringUtils.isBlank(voucherno))
        continue; 
      String period = billNoMap.get("period");
      byte b;
      int k;
      BXBusItemVO[] arrayOfBXBusItemVO1;
      for (k = (arrayOfBXBusItemVO1 = bxBusItemVOS).length, b = 0; b < k; ) {
        BXBusItemVO bxBusItemVO = arrayOfBXBusItemVO1[b];
        if (!Objects.isNull(bxBusItemVO)) {
          String invoice_number = StringUtils.isNotBlank(bxBusItemVO.getFphm()) ? bxBusItemVO.getFphm() : "";
          String invoice_code = StringUtils.isNotBlank(bxBusItemVO.getFpdm()) ? bxBusItemVO.getFpdm() : "";
          String cost_center = StringUtils.isNotBlank(bxBusItemVO.getDefitem46()) ? bxBusItemVO.getDefitem46() : "";
          if (!CollectionUtils.isNotEmpty(existInvoiceMap) || !existInvoiceMap.contains(String.valueOf(invoice_number) + invoice_code + cost_center + voucherno)) {
            InvoiceLedgerInfoVO invoiceLedgerInfoSaveVO = new InvoiceLedgerInfoVO();
            invoiceLedgerInfoSaveVO.setArrival_ticket_state(ArrivalTicketState.ArrivalTicketState_已到票.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setIs_arrival_ticket(UFBoolean.FALSE);
            invoiceLedgerInfoSaveVO.setInvoice_auth_type(InvoiceAuthType.InvoiceAuthType_待认证.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setSource_type(SourceType.SourceType_OA.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setBilltype("FPRZFPTZ");
            invoiceLedgerInfoSaveVO.setTranstypepk(ydpBillPk);
            invoiceLedgerInfoSaveVO.setTranstype("FPRZFPTZ-Cxx-001");
            invoiceLedgerInfoSaveVO.setSource_billno(jkbxHeaderVO.getZyx1());
            invoiceLedgerInfoSaveVO.setPk_group(jkbxHeaderVO.getPk_group());
            invoiceLedgerInfoSaveVO.setPk_org(jkbxHeaderVO.getPk_org());
            invoiceLedgerInfoSaveVO.setPk_org_v(jkbxHeaderVO.getPk_org_v());
            invoiceLedgerInfoSaveVO.setNc_source_type(NcSourceType.NcSourceType_报销单.getEnumValue().getValue());
            invoiceLedgerInfoSaveVO.setNc_source_billno(jkbxHeaderVO.getDjbh());
            invoiceLedgerInfoSaveVO.setVoucher_no(voucherno);
            invoiceLedgerInfoSaveVO.setPeriod(period);
            invoiceLedgerInfoSaveVO.setCost_center(bxBusItemVO.getDefitem46());
            invoiceLedgerInfoSaveVO.setThe_seller(bxBusItemVO.getHbbm());
            invoiceLedgerInfoSaveVO.setBuyer_taxno(bxBusItemVO.getDefitem50());
            invoiceLedgerInfoSaveVO.setInvoice_code(bxBusItemVO.getFpdm());
            invoiceLedgerInfoSaveVO.setInvoice_number(bxBusItemVO.getFphm());
            invoiceLedgerInfoSaveVO.setTax(bxBusItemVO.getTax_amount());
            invoiceLedgerInfoSaveVO.setTax_exclusive(bxBusItemVO.getTni_amount());
            invoiceLedgerInfoSaveVO.setTotal_price_with_tax(StringUtils.isNotBlank(bxBusItemVO.getDefitem36()) ? new UFDouble(bxBusItemVO.getDefitem36()) : UFDouble.ZERO_DBL);
            invoiceLedgerInfoSaveVO.setInvoice_date(StringUtils.isNotBlank(bxBusItemVO.getDefitem51()) ? new UFDate(bxBusItemVO.getDefitem51()) : null);
            invoiceLedgerInfoSaveVO.setDef1(bxBusItemVO.getVat_amount().toString());
            if (StringUtils.isNotBlank(bxBusItemVO.getFplxpk())) {
              String nccInvoiceType = (String)this.hyPubBO.findColValue("sscivm_invoice_type_map", "ncc_invoice_type", " oa_invoice_type = '" + bxBusItemVO.getFplxpk() + "'");
              invoiceLedgerInfoSaveVO.setInvoice_type(nccInvoiceType);
            } 
            invoiceLedgerInfoSaveVO.setApprovestatus(Integer.valueOf(BillStatusEnum.APPROVED.toIntValue()));
            invoiceLedgerInfoSaveVO.setStatus(2);
            AggInvoiceLedgerInfoVO aggInvoiceLedgerInfoVO = new AggInvoiceLedgerInfoVO();
            aggInvoiceLedgerInfoVO.setParent((ISuperVO)invoiceLedgerInfoSaveVO);
            saveVOList.add(aggInvoiceLedgerInfoVO);
          } 
        } 
        b++;
      } 
    } 
    return saveVOList;
  }
  
  private IBXBillPrivate getIBXBillPrivate() {
    return (IBXBillPrivate)NCLocator.getInstance().lookup(IBXBillPrivate.class);
  }
  
  private IInvoiceLedgerInfoVOService getIInvoiceLedgerInfoVOService() {
    return (IInvoiceLedgerInfoVOService)NCLocator.getInstance().lookup(IInvoiceLedgerInfoVOService.class);
  }
  
  private IArapPayBillQueryService getIArapPayBillQueryService() {
    return (IArapPayBillQueryService)NCLocator.getInstance().lookup(IArapPayBillQueryService.class);
  }
  
  private IArapPayableBillQueryService getIArapPayableBillQueryService() {
    return (IArapPayableBillQueryService)NCLocator.getInstance().lookup(IArapPayableBillQueryService.class);
  }
  
  private IArapReceivableBillQueryService getIArapReceivableBillQueryService() {
    return (IArapReceivableBillQueryService)NCLocator.getInstance().lookup(IArapReceivableBillQueryService.class);
  }
  
  private List<String> getExistInvoice(String distinctInvoiceSql, boolean flag) throws BusinessException {
    IInvoiceLedgerInfoVOService iInvoiceLedgerInfoVOService = getIInvoiceLedgerInfoVOService();
    InvoiceLedgerInfoVO[] invoiceLedgerInfoVOS = iInvoiceLedgerInfoVOService.listInvoiceLedgerInfoVOByCondition(distinctInvoiceSql);
    invoiceLedgerInfoVOS = (invoiceLedgerInfoVOS == null) ? new InvoiceLedgerInfoVO[0] : invoiceLedgerInfoVOS;
    List<InvoiceLedgerInfoVO> invoiceLedgerInfoVOList = Arrays.asList((InvoiceLedgerInfoVO[])invoiceLedgerInfoVOS.clone());
    return (List<String>)invoiceLedgerInfoVOList.stream().map(a -> {
          String invoice_number = StringUtils.isNotBlank(a.getInvoice_number()) ? a.getInvoice_number() : "";
          String invoice_code = StringUtils.isNotBlank(a.getInvoice_code()) ? a.getInvoice_code() : "";
          String cost_center = StringUtils.isNotBlank(a.getCost_center()) ? a.getCost_center() : "";
          String voucher_no = (StringUtils.isNotBlank(a.getVoucher_no()) && paramBoolean) ? a.getVoucher_no() : "";
          return String.valueOf(invoice_number) + invoice_code + cost_center + voucher_no;
        }).collect(Collectors.toList());
  }
  
  private boolean isWdp(String pk_tradetype) {
    return !(!"F1-Cxx-01".equals(pk_tradetype) && !"F1-Cxx-02".equals(pk_tradetype) && !"F1-Cxx-03".equals(pk_tradetype) && 
      !"F1-Cxx-04".equals(pk_tradetype) && !"F1-Cxx-05".equals(pk_tradetype) && 
      !"F1-Cxx-06".equals(pk_tradetype) && !"F1-Cxx-07".equals(pk_tradetype) && 
      !"F1-Cxx-08".equals(pk_tradetype) && !"F1-Cxx-09".equals(pk_tradetype) && 
      !"F1-Cxx-10".equals(pk_tradetype));
  }
}
